#include "TPTMoogLadderFilter.h"

CTPTMoogLadderFilter::CTPTMoogLadderFilter(void)
{
//	zMinusOneRegister = 0.0;
}

CTPTMoogLadderFilter::~CTPTMoogLadderFilter(void)
{
}

float CTPTMoogLadderFilter::doTPTMoogLPF(float xn)
{
	// calculate g
	float wd = 2*pi*fc;          
	float T  = 1/(float)filter1.getSampleRate();             
	float wa = (2/T)*tan(wd*T/2); 
	float g  = wa*T/2;  

	float G = g*g*g*g;
	float S = g*g*g*filter1.getStorageRegisterValue() + g*g*filter2.getStorageRegisterValue() + g*filter3.getStorageRegisterValue() + filter4.getStorageRegisterValue();

	// u is input to filters
	float u = (xn - k*S)/(1 + k*G);

	// four in series
	float filterOut = filter4.doFilterStage(filter3.doFilterStage(filter2.doFilterStage(filter1.doFilterStage(u))));

	return filterOut;
}
